
import { describe, test, it, expect } from 'vitest'
import {RuntimeConfig} from "@nuxt/schema";
import {AnyAbility} from "@casl/ability/dist/types";
import {AccessProfile, organizationState} from "~/types/interfaces";
import ConfigurationMenuBuilder from "~/services/layout/menuBuilder/configurationMenuBuilder";
import {MenuGroup} from "~/types/layout";
import {MENU_LINK_TYPE} from "~/types/enum/layout";

let runtimeConfig: RuntimeConfig
let ability: AnyAbility
let organizationProfile: organizationState
let accessProfile: AccessProfile
let menuBuilder: ConfigurationMenuBuilder

beforeEach(()=> {
    runtimeConfig = vi.fn() as any as RuntimeConfig
    ability = vi.fn() as any as AnyAbility
    organizationProfile = vi.fn() as any as organizationState
    accessProfile = vi.fn() as any as AccessProfile

    runtimeConfig.baseUrlAdminLegacy = 'https://mydomain.com/'

    menuBuilder = new ConfigurationMenuBuilder(runtimeConfig, ability, organizationProfile, accessProfile)
})


describe('getMenuName', () => {
    test('validate name', () => {
        expect(menuBuilder.getMenuName()).toEqual("Configuration")
    })
})


describe('build', () => {
    test('has all items', () => {
        ability.can = vi.fn(() => true)

        // Should return a MenuGroup
        const result = menuBuilder.build() as MenuGroup

        expect(result.label).toEqual('configuration')
        expect(result.icon).toEqual({name: 'fas fa-cogs'})
        // @ts-ignore
        expect(result.children.length).toEqual(13)
    })

    test('has no items', () => {
        ability.can = vi.fn(() => false)
        expect(menuBuilder.build()).toEqual(null)
    })

    test('has only rights for menu organization_page', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'organization_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'organization_page', icon: undefined, to: 'https://mydomain.com/organization', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu cmf_licence_generate', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'cmf_licence_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'cmf_licence_generate', icon: undefined, to: 'https://mydomain.com/cmf_licence/organization', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu place', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'place_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'place', icon: undefined, to: 'https://mydomain.com/places/list/', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu education', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'education_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'education', icon: undefined, to: 'https://mydomain.com/educations/list/', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu tag', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'tag_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'tag', icon: undefined, to: 'https://mydomain.com/taggs/list/', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu activities', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'activities_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'activities', icon: undefined, to: 'https://mydomain.com/activities/list/', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu transition_next_year', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'transition_next_year_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'transition_next_year', icon: undefined, to: 'https://mydomain.com/transition_next_year', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu course_duplication', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'course_duplication_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'course_duplication', icon: undefined, to: 'https://mydomain.com/duplicate_courses', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu import', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'import_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'import', icon: undefined, to: 'https://mydomain.com/import/all', type: MENU_LINK_TYPE.V1, active: false}
        )
    })
})
